/* Copyright: Mathias Imming, 2014
 * Verwendung und Weitergabe nur unter Creative-Commons-Lizenz */
#ifndef __USIC_H__
#define __USIC_H__

#include "stdint.h"

extern uint8_t dmx_rbuf[513];
extern uint8_t pwm1;
extern uint8_t pwm2;
extern uint16_t dim1;
extern uint16_t dim2;
extern uint16_t dim3;

// UART baud rate constants for 250.000kbps @ MCLK=32MHz
#define DMX_FDR_STEP 480UL
#define DMX_BRG_PDIV 2UL
#define DMX_BRG_PCTQ 1UL
#define DMX_BRG_DCTQ 9UL

// UART baud rate constants for 115.2kbps @ MCLK=32MHz
#define UART_FDR_STEP 553UL
#define UART_BRG_PDIV 4UL
#define UART_BRG_PCTQ 2UL
#define UART_BRG_DCTQ 9UL

/* von E1 reservierte Startcodes, keine herstellerspezifischen */
#define STARTCODE_LICHT		0x00	// E1.11 Licht

/* DMX-Protokoll-Lnge ohne Startcode 			*/
#define	DMX_MSG_LEN			512
/* DMX-Zyklen die ok sein mssen bei Wiederkehr */
#define DMX_OK_CNT			10


void USIC0_0_IRQHandler(void);
void USIC0_CH0_Init(void);

void USIC0_1_IRQHandler(void);
void USIC0_CH1_Init(void);

void USIC_INIT(void);

#endif
